package com.abi.qms.platform.service;


import com.abi.qms.platform.dto.req.DisableFactoryReq;
import com.abi.qms.platform.dto.req.EnableFactoryReq;
import com.abi.qms.platform.dto.req.GetFactoryDetailReq;
import com.abi.qms.platform.dto.req.ListFactoryReq;
import com.abi.qms.platform.dto.req.SaveFactoryReq;
import com.abi.qms.platform.dto.res.*;
import com.abi.task.common.excel.preperties.FactoryProperty;

import java.util.List;

/**
 * <p>
 * 供应商管理
 * </p>
 *
 * @author Andy.Tan
 */
public interface FactoryService {

    void saveFactory(SaveFactoryReq saveFactoryReq) throws Exception;

    ListFactoryRes listFactory(ListFactoryReq listFactoryReq) throws Exception;

    GetFactoryDetailRes getFactoryDetail(GetFactoryDetailReq getFactoryDetailReq) throws Exception;

    void enableFactory(EnableFactoryReq enableFactoryReq) throws Exception;

    void disableFactory(DisableFactoryReq disableFactoryReq) throws Exception;

    ExcelImportRes factoryExcelImport(List<FactoryProperty> factoryPropertyList) throws Exception;

    /**
     * 启用中的供应商列表
     * @return
     */
    ListFactoryEnableRes listFactoryEnable();

    /**
     * 包材厂下拉列表（数据权限隔离）
     * @return
     */
    ListPackageFactorySelectRes listPackageFactorySelect();

    /**
     * 啤酒厂下拉列表
     * @return
     */
    ListBeerFactorySelectRes listBeerFactorySelect();
}
